<template>
  <b-container fluid>
    <b-alert show :variant="alert" v-model="showAlert" dismissible>
        <strong>{{alertMessage}}</strong>
    </b-alert>
    <b-table
      responsive
      striped
      hover
      :sort-by.sync="sortBy"
      :sort-desc.sync="sortDesc"
      :items="results"
      :fields="fields"
      :current-page="currentPage"
      :per-page="perPage"
      class="table-platone"
    >
    <template #cell(username)="data">
        {{ data.item.username }}
      </template>
      <template #cell(topic)="data">
        {{ data.item.topic }}
      </template>
       <template #cell(wallet)="data">
        {{ data.item.wallet }}
      </template>
      <template #cell(status)="data">
        <h5><b-badge v-if="data.item.status==='REQUESTED'" variant="info">{{data.item.status}}</b-badge></h5>
        <h5><b-badge v-if="data.item.status==='ACCEPTED'" variant="success">{{data.item.status}}</b-badge></h5>
        <h5><b-badge v-if="data.item.status==='REFUSED'" variant="danger ">{{data.item.status}}</b-badge></h5>
        <h5><b-badge v-if="data.item.status===''" variant="">{{data.item.status}}</b-badge></h5>
      </template>
      <template #cell()="data">
        <b-button v-b-tooltip.hover title="Subscribe" size="sm" v-on:click="subscribe(user.username, data.item.topic)" :disabled="data.item.isDisabled">Subscribe</b-button>
      </template>
    </b-table>
    <b-pagination
      v-model="currentPage"
      :total-rows="results.length"
      :per-page="perPage"
      aria-controls="my-table"
    ></b-pagination>
  </b-container>
</template>

<style>
  input {
    text-align: center;
  }
  .home {
    text-align: center;
  }
  .home .lead {
    font-weight: 200;
    font-size: 1.5rem;
  }
  .b-search {
    margin-top: 10px;
    background-color: #497774;
  }
  .card {
    margin-top: 20px;
  }
  .json {
    text-align: left;
    width: 50%;
  }
  .hash {
    width: 50%;
  }
  .verifiedHash {
    margin-top: 40px;
  }
  .center {
    text-align: center;
  }
</style>

<script>
import ConsumerService from '@/services/ConsumerService'
import SubscriptionService from '@/services/SubscriptionService'

export default {
  name: 'home',
  mounted () {
    this.getProducers()
  },
  data () {
    return {
      user: this.$session.get('user'),
      result: null,
      hash: null,
      text: '',
      vHash: null,
      alert: 'light',
      loading: false,
      sortBy: 'start',
      sortDesc: true,
      results: [],
      producers: [],
      fields: [
        { key: 'username', label: 'Username', sortable: true },
        { key: 'topic', label: 'Topic', sortable: true },
        { key: 'wallet', label: 'Wallet', sortable: true },
        { key: 'status', label: 'Subscription Status', sortable: true },
        { key: 'action', label: 'Actions' }
      ],
      form: {},
      currentPage: 1,
      perPage: 10,
      showAlert: false,
      alertMessage: 'Successful subscription',
      isDisabled: false
    }
  },
  methods: {
    async getProducers () {
      this.results = []
      const response = await ConsumerService.getProducers()
      console.log('Response getProducers' + JSON.stringify(response.data))
      let producer = {}

      for (let i = 0; i < response.data.length; i += 1) {
        producer = {
          username: response.data[i].username,
          topic: response.data[i].topic,
          wallet: response.data[i].wallet
        }

        const subscription = await SubscriptionService.getSubscriptions(response.data[i].topic)
        console.log('subscription ' + JSON.stringify(subscription))
        for (let j = 0; j < subscription.data.length; j += 1) {
          const consumer = subscription.data[j].id_consumer
          if (consumer === this.user.username) {
            console.log('subscriptionsByUser' + JSON.stringify(subscription.data[j]))
            const status = subscription.data[j].status
            console.log('status ' + status)
            if (status === 'REQUESTED' || status === 'ACCEPTED' || status === 'REFUSED') {
              this.isDisabled = true
            } else {
              this.isDisabled = false
            }
            console.log('isDisabled ' + this.isDisabled)
            producer = {
              username: response.data[i].username,
              topic: response.data[i].topic,
              wallet: response.data[i].wallet,
              status: subscription.data[j].status,
              isDisabled: this.isDisabled
            }
          }
        }
        this.results.push(producer)
      }
    },
    async subscribe (idConsumer, topic) {
      this.showAlert = true
      this.alert = 'success'
      setTimeout(() => {
        this.showAlert = false
      }, 4000)
      const params = {}
      params.id_consumer = idConsumer
      params.topic = topic
      params.status = 'REQUESTED'
      params.creation_date = Date.now()

      await ConsumerService.subscribe(params)
      await this.getProducers()
    }
  }
}
</script>
